# Hunter's Say Sorry Addon
#  
# Install instructions:
#       1. Install Mattie's EventScripts 2.0 plugin:
#           http://mattie.info/cs/
#
#       2. Copy and upload this script to:
#           <gamedir>/addons/eventscripts/say_sorry/
#
#       3. Add the following line somewhere in autoexec.cfg:
#           es_load say_sorry
#
################################################################################
#import EventScripts
import es
#import Libraries
import popuplib
import playerlib
import settinglib
import gamethread
import operator
import time
#import Psyco Compiler
import psyco
psyco.full()

# Addon Information
info = es.AddonInfo()
info.name = "Say Sorry"
info.version = "4.0.0"
info.author = "Hunter"
info.url = "http://addons.eventscripts.com/addons/user/289"
info.description = "Allows teamattackers to say 'Sorry' quickly"
info.basename = "say_sorry"

hunter_say_sorry_ver        = info.version
hunter_say_sorry_text       = 'Hunters '+info.name+', www.sourceplugins.de, '+info.version+', ES 2.0.0.247+ (Python Version)'

# Server Variables
say_sorry_savetime          = es.ServerVar('say_sorry_savetime', '30', 'How much days should inactive users be stored, before their data get deleted? ( default = 30 )')
say_sorry_default           = es.ServerVar('say_sorry_default', 'all', 'Default user setting ( all / tk / ta / off )')
say_sorry_limit             = es.ServerVar('say_sorry_limit', '5', 'Allowed TA\'s ( default = 5 )')
say_sorry_mode              = es.ServerVar('say_sorry_mode', 'kick', 'Kick or Ban ( kick / ban )')
say_sorry_ban_time          = es.ServerVar('say_sorry_ban_time', '5', 'Bantime ( default = 5 | only if mode = ban )')
say_sorry_sound             = es.ServerVar('say_sorry_sound', 'vo/npc/female01/sorry01.wav', 'Define Sorry Sound ( relativ to sounds/ )')

# Settinglib Object
say_sorry_setting           = settinglib.create('saysorry', 'Say Sorry Settings', 'list')

# Global Variables
say_sorry_players           = {}
say_sorry_popups            = {}

def load():
    public = es.ServerVar('hu_ss', info.version, info.name)
    public.makepublic()

    say_sorry_setting.addoption('all', 'Popop on TK/TA')
    say_sorry_setting.addoption('tk', 'Popop on TK')
    say_sorry_setting.addoption('ta', 'Popop on TA')
    say_sorry_setting.addoption('off', 'Popop disabled')
    say_sorry_setting.setdefault(str(say_sorry_default))
    say_sorry_setting.addsound('ui/buttonclick.wav')

    es.regsaycmd('!sorry', 'say_sorry/saycmd', 'Say Sorry Settings')
    es.log(hunter_say_sorry_text)
    es.msg('#multi', '#green[SaySorry] #defaultLoaded')
    
def unload():
    for popup in say_sorry_popups:
        say_sorry_popups[popup].delete()

    es.unregsaycmd('!sorry')
    es.msg('#multi', '#green[SaySorry] #defaultUnloaded') 

def es_map_start(event_var):
    say_sorry_setting.clear(int(say_sorry_savetime)*86400)
    say_sorry_players = {}

def es_client_command(event_var):
    if (str(event_var['command']) == '!hunter_say_sorry_ver') or (str(event_var['command']) == '!hunter_all_ver'):
        es.cexec(int(event_var['userid']), 'echo '+hunter_say_sorry_text)

def player_activate(event_var):
    say_sorry_setting.updateTime(int(event_var['userid']))
    gamethread.delayed(30, es.cexec, (int(event_var['userid']), 'echo '+hunter_say_sorry_text))
    gamethread.delayed(15, es.tell, (int(event_var['userid']), '#multi', '#green[SaySorry] #defaultSay \'!sorry\' for settings menu'))

def player_disconnect(event_var):
    say_sorry_setting.updateTime(int(event_var['userid']))
    if int(event_var['userid']) in say_sorry_popups:
        del say_sorry_popups[int(event_var['userid'])]

def player_hurt(event_var):
    if event_var['attacker'] and event_var['es_attackerteam'] and int(event_var['userid']) != int(event_var['attacker']) and int(event_var['es_userteam']) == int(event_var['es_attackerteam']):
        player = playerlib.getPlayer(int(event_var['attacker']))
        if int(player.attributes['isbot']) == 0:
            if not player.uniqueid() in say_sorry_players:
                say_sorry_players[player.uniqueid()] = {'hits':0, 'user':0, 'wait':False, 'lock':False}
            if not say_sorry_players[player.uniqueid()]['wait']:
                say_sorry_players[player.uniqueid()]['hits'] += 1
                say_sorry_players[player.uniqueid()]['wait'] = True
                gamethread.delayed(3, operator.setitem, (say_sorry_players[player.uniqueid()], 'wait', False))
                if not say_sorry_players[player.uniqueid()]['lock']:
                    say_sorry_players[player.uniqueid()]['user'] = int(event_var['userid'])
                    say_sorry_players[player.uniqueid()]['lock'] = True
                    gamethread.delayed(30, operator.setitem, (say_sorry_players[player.uniqueid()], 'lock', False))
                    if str(say_sorry_setting.get(int(player))) == 'all' or (str(say_sorry_setting.get(int(player))) == 'tk' and int(event_var['es_userdead']) == 1) or (str(say_sorry_setting.get(int(player))) == 'ta' and int(event_var['es_userdead']) == 0):
                        say_sorry_popups[int(player)] = popuplib.create('say_sorry_%s'%int(player))
                        say_sorry_popups[int(player)].addline('Say Sorry Menu')
                        say_sorry_popups[int(player)].addline('------------------')
                        say_sorry_popups[int(player)].addline('->1. Say sorry!')
                        say_sorry_popups[int(player)].addline('->2. Say nothing!')
                        say_sorry_popups[int(player)].addline('------------------')
                        if str(say_sorry_setting.get(int(player))) == 'all':
                            say_sorry_popups[int(player)].addline('Popup on TA/TK')
                        elif str(say_sorry_setting.get(int(player))) == 'tk':
                            say_sorry_popups[int(player)].addline('Popup on TK')
                        elif str(say_sorry_setting.get(int(player))) == 'ta':
                            say_sorry_popups[int(player)].addline('Popup on TA')
                        else:
                            say_sorry_popups[int(player)].addline('Popup disabled')
                        say_sorry_popups[int(player)].addline('------------------')
                        say_sorry_popups[int(player)].addline('->0. Cancel')
                        say_sorry_popups[int(player)].menuselect = _select_sorry
                        say_sorry_popups[int(player)].send(int(player))
                        return
                    else:
                        es.tell(int(player), '#multi', '#green[SaySorry] #lightgreen%1/%2 TA\'s! Say !sorry to open Sorry Settings Menu!' % (say_sorry_players[player.uniqueid()]['hits'], say_sorry_limit))    
                else:
                    es.tell(int(player), '#multi', '#green[SaySorry] #default%s/%s TA\'s without saying Sorry!' % (say_sorry_players[player.uniqueid()]['hits'], say_sorry_limit))
                    es.tell(int(player), '#multi', '#green[SaySorry] #lightgreenYou can\'t say Sorry, so often!')
                if say_sorry_players[player.uniqueid()]['hits'] >= int(say_sorry_limit):
                    if str(say_sorry_mode) == 'ban':
                        player.banId(int(say_sorry_ban_time))
                        player.banAddr(int(say_sorry_ban_time))
                        es.msg('#multi', '#green[SaySorry] #defaultPlayer #lightgreen%s #defaulthas been banned %s because of to much TK\'s and TA\'s!' % (player.attributes['name'], 'for '+str(say_sorry_ban_time)+' minutes' if int(say_sorry_ban_time) else 'permanently'))
                    else:
                        es.msg('#multi', '#green[SaySorry] #defaultPlayer #lightgreen%s #defaulthas been kicked because of to much TK\'s and TA\'s!' % (player.attributes['name']))
                    gamethread.queue(player.kick, ('Too much Teamattacks!'))

def _select_sorry(userid, choice, popupid):
    player = playerlib.getPlayer(userid)
    if player.uniqueid() in say_sorry_players:
        if say_sorry_players[player.uniqueid()]['user'] in es.getUseridList():
            if choice == 1:
                say_sorry_players[player.uniqueid()]['hits'] -= 1
                es.cexec(say_sorry_players[player.uniqueid()]['user'], 'play %s' % say_sorry_sound)
                es.cexec(userid, 'play %s' % say_sorry_sound)
                es.sexec(userid, 'say_team Sorry for Teamattack!')
            if say_sorry_players[player.uniqueid()]['hits'] >= int(say_sorry_limit):
                if str(say_sorry_mode) == 'ban':
                    player.banId(int(say_sorry_ban_time))
                    player.banAddr(int(say_sorry_ban_time))
                    es.msg('#multi', '#green[SaySorry] #defaultPlayer #lightgreen%s #defaulthas been banned %s because of to much TK\'s and TA\'s!' % (player.attributes['name'], 'for '+str(say_sorry_ban_time)+' minutes' if int(say_sorry_ban_time) else 'permanently'))
                else:
                    es.msg('#multi', '#green[SaySorry] #defaultPlayer #lightgreen%s #defaulthas been kicked because of to much TK\'s and TA\'s!' % (player.attributes['name']))
                gamethread.queue(player.kick, ('Too much Teamattacks!'))
            else:
                es.tell(int(player), '#multi', '#green[SaySorry] #default%s/%s TA\'s without saying Sorry!' % (say_sorry_players[player.uniqueid()]['hits'], say_sorry_limit))
            if choice >= 10:
                es.cexec(userid, 'play ui/buttonclickrelease.wav')
            elif choice > 2 and popuplib.exists(popupid):
                popuplib.find(popupid).send(userid)

def saycmd():
    say_sorry_setting.send(int(es.getcmduserid()))
